- [HTTP request](https://docs.cloud.google.com/compute/docs/reference/rest/2026-09-01/instances/updateNetworkInterface#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/compute/docs/reference/rest/2026-09-01/instances/updateNetworkInterface#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/compute/docs/reference/rest/2026-09-01/instances/updateNetworkInterface#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/compute/docs/reference/rest/2026-09-01/instances/updateNetworkInterface#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/2026-09-01/instances/updateNetworkInterface#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/compute/docs/reference/rest/2026-09-01/instances/updateNetworkInterface#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/2026-09-01/instances/updateNetworkInterface#body.Operation.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/2026-09-01/instances/updateNetworkInterface#body.Operation.SCHEMA_REPRESENTATION.error.SCHEMA_REPRESENTATION)
      - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/2026-09-01/instances/updateNetworkInterface#body.Operation.SCHEMA_REPRESENTATION.error.SCHEMA_REPRESENTATION.error_details.SCHEMA_REPRESENTATION)
      - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/2026-09-01/instances/updateNetworkInterface#body.Operation.SCHEMA_REPRESENTATION.error.SCHEMA_REPRESENTATION.error_details.SCHEMA_REPRESENTATION_1)
      - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/2026-09-01/instances/updateNetworkInterface#body.Operation.SCHEMA_REPRESENTATION.error.SCHEMA_REPRESENTATION.error_details.SCHEMA_REPRESENTATION_2)
      - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/2026-09-01/instances/updateNetworkInterface#body.Operation.SCHEMA_REPRESENTATION.error.SCHEMA_REPRESENTATION.error_details.SCHEMA_REPRESENTATION_3)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/2026-09-01/instances/updateNetworkInterface#body.Operation.SCHEMA_REPRESENTATION.warning.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/2026-09-01/instances/updateNetworkInterface#body.Operation.SCHEMA_REPRESENTATION.set_common_instance_metadata_operation_metadata.inlinedField_1.map_entry1.value.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/2026-09-01/instances/updateNetworkInterface#body.Operation.SCHEMA_REPRESENTATION.get_version_operation_metadata.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/2026-09-01/instances/updateNetworkInterface#body.Operation.SCHEMA_REPRESENTATION.get_health_operation_metadata.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/compute/docs/reference/rest/2026-09-01/instances/updateNetworkInterface#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/compute/docs/reference/rest/2026-09-01/instances/updateNetworkInterface#body.aspect_1)
- [Try it!](https://docs.cloud.google.com/compute/docs/reference/rest/2026-09-01/instances/updateNetworkInterface#try-it)

API Version : 2026-09-01
Updates an instance's network interface. This method can only update an interface's alias IP range and attached network. See [Modifying alias IP ranges for an existing instance](https://docs.cloud.google.com/vpc/docs/configure-alias-ip-ranges#modifying_alias_ip_ranges_for_an_existing_instance) for instructions on changing alias IP ranges. See [Migrating a VM between networks](https://docs.cloud.google.com/compute/docs/instances/migrating-interfaces-between-networks) for instructions on migrating an interface. This method follows PATCH semantics.

### HTTP request

Choose an endpoint:
global africa-south1 asia-east1 asia-east2 asia-northeast1 asia-northeast2 asia-northeast3 asia-south1 asia-south2 asia-southeast1 asia-southeast2 asia-southeast3 australia-southeast1 australia-southeast2 europe-central2 europe-north1 europe-north2 europe-southwest1 europe-west1 europe-west10 europe-west12 europe-west2 europe-west3 europe-west4 europe-west6 europe-west8 europe-west9 me-central1 me-central2 me-west1 northamerica-northeast1 northamerica-northeast2 northamerica-south1 southamerica-east1 southamerica-west1 us-central1 us-east1 us-east4 us-east5 us-south1 us-west1 us-west2 us-west3 us-west4   
`PATCH https://compute.googleapis.com/compute/v1/projects/{project}/zones/{zone}/instances/{instance}/updateNetworkInterface?$apiVersion=2026-09-01`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `project` | `string` Project ID for this request. |
| `zone` | `string` The name of the zone for this request. |
| `instance` | `string` The instance name for this request. |

### Query parameters

| Parameters ||
|---|---|
| `requestId` | `string` An optional request ID to identify requests. Specify a unique request ID so that if you must retry your request, the server will know to ignore the request if it has already been completed. For example, consider a situation where you make an initial request and the request times out. If you make the request again with the same request ID, the server can check if original operation with the same request ID was received, and if so, will ignore the second request. This prevents clients from accidentally creating duplicate commitments. The request ID must be a valid [UUID](https://tools.ietf.org/html/rfc4122) with the exception that zero UUID is not supported (`00000000-0000-0000-0000-000000000000`). |
| `networkInterface` | `string` The name of the network interface to update. |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "kind": string, "network": string, "subnetwork": string, "networkIP": string, "ipv6Address": string, "internalIpv6PrefixLength": integer, "name": string, "accessConfigs": [ { "kind": string, "type": enum, "name": string, "natIP": string, "externalIpv6": string, "externalIpv6PrefixLength": integer, "setPublicPtr": boolean, "publicPtrDomainName": string, "networkTier": enum, "securityPolicy": string } ], "ipv6AccessConfigs": [ { "kind": string, "type": enum, "name": string, "natIP": string, "externalIpv6": string, "externalIpv6PrefixLength": integer, "setPublicPtr": boolean, "publicPtrDomainName": string, "networkTier": enum, "securityPolicy": string } ], "aliasIpRanges": [ { "ipCidrRange": string, "subnetworkRangeName": string } ], "aliasIpv6Ranges": [ { "ipCidrRange": string, "subnetworkRangeName": string } ], "fingerprint": string, "stackType": enum, "ipv6AccessType": enum, "queueCount": integer, "nicType": enum, "networkAttachment": string, "parentNicName": string, "vlan": integer, "igmpQuery": enum, "serviceClassId": string, "enableVpcScopedDns": boolean } ``` |

| Fields ||
|---|---|
| `kind` | `string` Output only. Type of the resource. Always `compute#networkInterface` for network interfaces. |
| `network` | `string` URL of the VPC network resource for this instance. When creating an instance, if neither the network nor the subnetwork is specified, the default network `global/networks/default` is used. If the selected project doesn't have the default network, you must specify a network or subnet. If the network is not specified but the subnetwork is specified, the network is inferred. If you specify this property, you can specify the network as a full or partial URL. For example, the following are all valid URLs: - `https://www.googleapis.com/compute/v1/projects/project/global/networks/network` - `projects/project/global/networks/network` - `global/networks/default` <br /> |
| `subnetwork` | `string` The URL of the Subnetwork resource for this instance. If the network resource is in [legacy](https://docs.cloud.google.com/vpc/docs/legacy) mode, do not specify this field. If the network is in auto subnet mode, specifying the subnetwork is optional. If the network is in custom subnet mode, specifying the subnetwork is required. If you specify this field, you can specify the subnetwork as a full or partial URL. For example, the following are all valid URLs: - `https://www.googleapis.com/compute/v1/projects/project/regions/region/subnetworks/subnetwork` - `regions/region/subnetworks/subnetwork` <br /> |
| `networkIP` | `string` An IPv4 internal IP address to assign to the instance for this network interface. If not specified by the user, an unused internal IP is assigned by the system. |
| `ipv6Address` | `string` An IPv6 internal network address for this network interface. To use a static internal IP address, it must be unused and in the same region as the instance's zone. If not specified, Google Cloud will automatically assign an internal IPv6 address from the instance's subnetwork. |
| `internalIpv6PrefixLength` | `integer` The prefix length of the primary internal IPv6 range. |
| `name` | `string` Output only. The name of the network interface, which is generated by the server. For a VM, the network interface uses the `nicN` naming format. Where `N` is a value between `0` and `7`. The default interface value is `nic0`. |
| `accessConfigs[]` | `object` An array of configurations for this interface. Currently, only one access config, `ONE_TO_ONE_NAT`, is supported. If there are no `accessConfigs` specified, then this instance will have no external internet access. |
| `accessConfigs[].kind` | `string` Output only. Type of the resource. Always `compute#accessConfig` for access configs. |
| `accessConfigs[].type` | `enum` The type of configuration. In `accessConfigs` (IPv4), the default and only option is `ONE_TO_ONE_NAT`. In `ipv6AccessConfigs`, the default and only option is `DIRECT_IPV6`. |
| `accessConfigs[].name` | `string` The name of this access configuration. In `accessConfigs` (IPv4), the default and recommended name is `External NAT`, but you can use any arbitrary string, such as `My external IP` or `Network Access`. In `ipv6AccessConfigs`, the recommend name is `External IPv6`. |
| `accessConfigs[].natIP` | `string` Applies to `accessConfigs` (IPv4) only. An [external IP address](https://docs.cloud.google.com/compute/docs/ip-addresses#externaladdresses) associated with this instance. Specify an unused static external IP address available to the project or leave this field undefined to use an IP from a shared ephemeral IP address pool. If you specify a static external IP address, it must live in the same region as the zone of the instance. |
| `accessConfigs[].externalIpv6` | `string` Applies to `ipv6AccessConfigs` only. The first IPv6 address of the external IPv6 range associated with this instance, prefix length is stored in `externalIpv6PrefixLength` in `ipv6AccessConfig`. To use a static external IP address, it must be unused and in the same region as the instance's zone. If not specified, Google Cloud will automatically assign an external IPv6 address from the instance's subnetwork. |
| `accessConfigs[].externalIpv6PrefixLength` | `integer` Applies to `ipv6AccessConfigs` only. The prefix length of the external IPv6 range. |
| `accessConfigs[].setPublicPtr` | `boolean` Specifies whether a public DNS 'PTR' record should be created to map the external IP address of the instance to a DNS domain name. This field is not used in `ipv6AccessConfig`. A default PTR record will be created if the VM has external IPv6 range associated. |
| `accessConfigs[].publicPtrDomainName` | `string` The DNS domain name for the public PTR record. You can set this field only if the `setPublicPtr` field is enabled in `accessConfig`. If this field is unspecified in `ipv6AccessConfig`, a default PTR record will be created for first IP in associated external IPv6 range. |
| `accessConfigs[].networkTier` | `enum` This signifies the networking tier used for configuring this access configuration and can only take the following values: `PREMIUM`, `STANDARD`. If an AccessConfig is specified without a valid external IP address, an ephemeral IP will be created with this networkTier. If an AccessConfig with a valid external IP address is specified, it must match that of the networkTier associated with the Address resource owning that IP. |
| `accessConfigs[].securityPolicy` | `string` The resource URL for the security policy associated with this access config. |
| `ipv6AccessConfigs[]` | `object` An array of IPv6 access configurations for this interface. Currently, only one IPv6 access config, `DIRECT_IPV6`, is supported. If there is no `ipv6AccessConfig` specified, then this instance will have no external IPv6 Internet access. |
| `ipv6AccessConfigs[].kind` | `string` Output only. Type of the resource. Always `compute#accessConfig` for access configs. |
| `ipv6AccessConfigs[].type` | `enum` The type of configuration. In `accessConfigs` (IPv4), the default and only option is `ONE_TO_ONE_NAT`. In `ipv6AccessConfigs`, the default and only option is `DIRECT_IPV6`. |
| `ipv6AccessConfigs[].name` | `string` The name of this access configuration. In `accessConfigs` (IPv4), the default and recommended name is `External NAT`, but you can use any arbitrary string, such as `My external IP` or `Network Access`. In `ipv6AccessConfigs`, the recommend name is `External IPv6`. |
| `ipv6AccessConfigs[].natIP` | `string` Applies to `accessConfigs` (IPv4) only. An [external IP address](https://docs.cloud.google.com/compute/docs/ip-addresses#externaladdresses) associated with this instance. Specify an unused static external IP address available to the project or leave this field undefined to use an IP from a shared ephemeral IP address pool. If you specify a static external IP address, it must live in the same region as the zone of the instance. |
| `ipv6AccessConfigs[].externalIpv6` | `string` Applies to `ipv6AccessConfigs` only. The first IPv6 address of the external IPv6 range associated with this instance, prefix length is stored in `externalIpv6PrefixLength` in `ipv6AccessConfig`. To use a static external IP address, it must be unused and in the same region as the instance's zone. If not specified, Google Cloud will automatically assign an external IPv6 address from the instance's subnetwork. |
| `ipv6AccessConfigs[].externalIpv6PrefixLength` | `integer` Applies to `ipv6AccessConfigs` only. The prefix length of the external IPv6 range. |
| `ipv6AccessConfigs[].setPublicPtr` | `boolean` Specifies whether a public DNS 'PTR' record should be created to map the external IP address of the instance to a DNS domain name. This field is not used in `ipv6AccessConfig`. A default PTR record will be created if the VM has external IPv6 range associated. |
| `ipv6AccessConfigs[].publicPtrDomainName` | `string` The DNS domain name for the public PTR record. You can set this field only if the `setPublicPtr` field is enabled in `accessConfig`. If this field is unspecified in `ipv6AccessConfig`, a default PTR record will be created for first IP in associated external IPv6 range. |
| `ipv6AccessConfigs[].networkTier` | `enum` This signifies the networking tier used for configuring this access configuration and can only take the following values: `PREMIUM`, `STANDARD`. If an AccessConfig is specified without a valid external IP address, an ephemeral IP will be created with this networkTier. If an AccessConfig with a valid external IP address is specified, it must match that of the networkTier associated with the Address resource owning that IP. |
| `ipv6AccessConfigs[].securityPolicy` | `string` The resource URL for the security policy associated with this access config. |
| `aliasIpRanges[]` | `object` An array of alias IP ranges for this network interface. You can only specify this field for network interfaces in VPC networks. |
| `aliasIpRanges[].ipCidrRange` | `string` The IP alias ranges to allocate for this interface. This IP CIDR range must belong to the specified subnetwork and cannot contain IP addresses reserved by system or used by other network interfaces. This range may be a single IP address (such as `10.2.3.4`), a netmask (such as `/24`) or a CIDR-formatted string (such as `10.1.2.0/24`). |
| `aliasIpRanges[].subnetworkRangeName` | `string` The name of a subnetwork secondary IP range from which to allocate an IP alias range. If not specified, the primary range of the subnetwork is used. |
| `aliasIpv6Ranges[]` | `object` An array of alias IPv6 ranges for this network interface. You can only specify this field for network interfaces in VPC networks. |
| `aliasIpv6Ranges[].ipCidrRange` | `string` The IP alias ranges to allocate for this interface. This IP CIDR range must belong to the specified subnetwork and cannot contain IP addresses reserved by system or used by other network interfaces. This range may be a single IP address (such as `10.2.3.4`), a netmask (such as `/24`) or a CIDR-formatted string (such as `10.1.2.0/24`). |
| `aliasIpv6Ranges[].subnetworkRangeName` | `string` The name of a subnetwork secondary IP range from which to allocate an IP alias range. If not specified, the primary range of the subnetwork is used. |
| `fingerprint` | `string (https://developers.google.com/discovery/v1/type-format format)` Fingerprint hash of contents stored in this network interface. This field will be ignored when inserting an `Instance` or adding a `NetworkInterface`. An up-to-date fingerprint must be provided in order to update the `NetworkInterface`. The request will fail with error `400 Bad Request` if the fingerprint is not provided, or `412 Precondition Failed` if the fingerprint is out of date. A base64-encoded string. |
| `stackType` | `enum` The stack type for this network interface. To assign only IPv4 addresses, use IPV4_ONLY. To assign both IPv4 and IPv6 addresses, use `IPV4_IPV6`. If not specified, `IPV4_ONLY` is used. This field can be both set at instance creation and update network interface operations. |
| `ipv6AccessType` | `enum` Output only. One of EXTERNAL, INTERNAL to indicate whether the IP can be accessed from the Internet. This field is always inherited from its subnetwork. Valid only if `stackType` is `IPV4_IPV6`. |
| `queueCount` | `integer` The networking queue count that's specified by users for the network interface. Both Rx and Tx queues will be set to this number. It'll be empty if not specified by the users. |
| `nicType` | `enum` The type of vNIC to be used on this interface. This may be gVNIC or VirtioNet. |
| `networkAttachment` | `string` The URL of the network attachment that this interface should connect to in the following format: projects/{projectNumber}/regions/{region_name}/networkAttachments/{network_attachment_name}. |
| `parentNicName` | `string` Name of the parent network interface of a dynamic network interface. |
| `vlan` | `integer` VLAN tag of a dynamic network interface, must be an integer in the range from 2 to 255 inclusively. |
| `igmpQuery` | `enum` Indicate whether igmp query is enabled on the network interface or not. If enabled, also indicates the version of IGMP supported. |
| `serviceClassId` | `string` Optional. Producer Service's Service class Id for the region of this network interface. Can only be used with networkAttachment. It is not possible to use on its own however, networkAttachment can be used without serviceClassId. |
| `enableVpcScopedDns` | `boolean` Optional. If true, DNS resolution will be enabled over this interface. Only valid with networkAttachment. |

### Response body

Represents an Operation resource.

Google Compute Engine has three Operation resources:

- [Global](https://docs.cloud.google.com/compute/docs/reference/rest/v1/globalOperations)
- [Regional](https://docs.cloud.google.com/compute/docs/reference/rest/v1/regionOperations)
- [Zonal](https://docs.cloud.google.com/compute/docs/reference/rest/v1/zoneOperations)

You can use an operation resource to manage asynchronous API requests. For more information, read [Handling API responses](https://docs.cloud.google.com/compute/docs/api/how-tos/api-requests-responses#handling_api_responses).

Operations can be global, regional or zonal.

- For global operations, use the `globalOperations` resource.
- For regional operations, use the `regionOperations` resource.
- For zonal operations, use the `zoneOperations` resource.

<br />

For more information, read [Global, Regional, and Zonal Resources](https://docs.cloud.google.com/compute/docs/regions-zones/global-regional-zonal-resources).

Note that completed Operation resources have a limited [retention period.](https://cloud.google.com/compute/docs/instances/viewing-compute-operations#operation-retention-period)

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "kind": string, "id": string, "creationTimestamp": string, "name": string, "zone": string, "clientOperationId": string, "operationType": string, "targetLink": string, "targetId": string, "status": enum, "statusMessage": string, "user": string, "progress": integer, "insertTime": string, "startTime": string, "endTime": string, "error": { "errors": [ { "code": string, "location": string, "message": string, "errorDetails": [ { "errorInfo": { "reason": string, "domain": string, "metadatas": { string: string, ... } }, "quotaInfo": { "metricName": string, "limitName": string, "dimensions": { string: string, ... }, "limit": number, "futureLimit": number, "rolloutStatus": enum }, "help": { "links": [ { "description": string, "url": string } ] }, "localizedMessage": { "locale": string, "message": string } } ] } ] }, "warnings": [ { "code": enum, "message": string, "data": [ { "key": string, "value": string } ] } ], "httpErrorStatusCode": integer, "httpErrorMessage": string, "selfLink": string, "region": string, "description": string, "operationGroupId": string, // The following is a list of mutually exclusive fields. At most one of the // fields will be set in a response: "setCommonInstanceMetadataOperationMetadata": { "clientOperationId": string, "perLocationOperations": { string: { "state": enum, "error": { "code": integer, "message": string, "details": [ { "@type": string, field1: ..., ... } ] } }, ... } }, "instancesBulkInsertOperationMetadata": { "perLocationStatus": { string: { "status": enum, "targetVmCount": integer, "createdVmCount": integer, "failedToCreateVmCount": integer, "deletedVmCount": integer }, ... } }, "getVersionOperationMetadata": { "inlineSbomInfo": { "currentComponentVersions": { string: string, ... }, "targetComponentVersions": { string: string, ... } } }, "getHealthOperationMetadata": { "healthInfo": { "healthStatus": enum, "unhealthyReason": enum, "repairCategory": enum, "availabilitySloStatus": enum, "updateTime": string } } // End of mutually exclusive fields. } ``` |

| Fields ||
|---|---|
| `kind` | `string` Output only. Type of the resource. Always `compute#operation` for Operation resources. |
| `id` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. The unique identifier for the operation. This identifier is defined by the server. |
| `creationTimestamp` | `string` \[Deprecated\] This field is deprecated. |
| `name` | `string` Output only. Name of the operation. |
| `zone` | `string` Output only. The URL of the zone where the operation resides. Only applicable when performing per-zone operations. |
| `clientOperationId` | `string` Output only. The value of `requestId` if you provided it in the request. Not present otherwise. |
| `operationType` | `string` Output only. The type of operation, such as `insert`, `update`, or `delete`, and so on. |
| `targetLink` | `string` Output only. The URL of the resource that the operation modifies. For operations related to creating a snapshot, this points to the disk that the snapshot was created from. |
| `targetId` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. The unique target ID, which identifies a specific incarnation of the target resource. |
| `status` | `enum` Output only. The status of the operation, which can be one of the following: `PENDING`, `RUNNING`, or `DONE`. |
| `statusMessage` | `string` Output only. An optional textual description of the current status of the operation. |
| `user` | `string` Output only. User who requested the operation, for example: `user@example.com` or `alice_smith_identifier (global/workforcePools/example-com-us-employees)`. |
| `progress` | `integer` Output only. An optional progress indicator that ranges from 0 to 100. There is no requirement that this be linear or support any granularity of operations. This should not be used to guess when the operation will be complete. This number should monotonically increase as the operation progresses. |
| `insertTime` | `string` Output only. The time that this operation was requested. This value is in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. |
| `startTime` | `string` Output only. The time that this operation was started by the server. This value is in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. |
| `endTime` | `string` Output only. The time that this operation was completed. This value is in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. |
| `error` | `object` Output only. If errors are generated during processing of the operation, this field will be populated. |
| `error.errors[]` | `object` Output only. The array of errors encountered while processing this operation. |
| `error.errors[].code` | `string` Output only. The error type identifier for this error. |
| `error.errors[].location` | `string` Output only. Indicates the field in the request that caused the error. This property is optional. |
| `error.errors[].message` | `string` Output only. An optional, human-readable error message. |
| `error.errors[].errorDetails[]` | `object` Output only. An optional list of messages that contain the error details. There is a set of defined message types to use for providing details.The syntax depends on the error code. For example, QuotaExceededInfo will have details when the error code is QUOTA_EXCEEDED. |
| `error.errors[].errorDetails[].errorInfo` | `object` Error information containing structured domain, reason, and metadata. |
| `error.errors[].errorDetails[].errorInfo.reason` | `string` The reason of the error. This is a constant value that identifies the proximate cause of the error. Error reasons are unique within a particular domain of errors. This should be at most 63 characters and match a regular expression of `[A-Z][A-Z0-9_]+[A-Z0-9]`, which represents UPPER_SNAKE_CASE. |
| `error.errors[].errorDetails[].errorInfo.domain` | `string` The logical grouping to which the "reason" belongs. The error domain is typically the registered service name of the tool or product that generates the error. Example: "pubsub.googleapis.com". If the error is generated by some common infrastructure, the error domain must be a globally unique value that identifies the infrastructure. For Google API infrastructure, the error domain is "googleapis.com". |
| `error.errors[].errorDetails[].errorInfo.metadatas` | `map (key: string, value: string)` Additional structured details about this error. Keys must match a regular expression of `[a-z][a-zA-Z0-9-_]+` but should ideally be lowerCamelCase. Also, they must be limited to 64 characters in length. When identifying the current value of an exceeded limit, the units should be contained in the key, not the value. For example, rather than `{"instanceLimit": "100/request"}`, should be returned as, `{"instanceLimitPerRequest": "100"}`, if the client exceeds the number of instances that can be created in a single (batch) request. |
| `error.errors[].errorDetails[].quotaInfo` | `object` Details about quota limits and metrics when a quota is exceeded. |
| `error.errors[].errorDetails[].quotaInfo.metricName` | `string` The Compute Engine quota metric name. |
| `error.errors[].errorDetails[].quotaInfo.limitName` | `string` The name of the quota limit. |
| `error.errors[].errorDetails[].quotaInfo.dimensions` | `map (key: string, value: string)` The map holding related quota dimensions. |
| `error.errors[].errorDetails[].quotaInfo.limit` | `number` Current effective quota limit. The limit's unit depends on the quota type or metric. |
| `error.errors[].errorDetails[].quotaInfo.futureLimit` | `number` Future quota limit being rolled out. The limit's unit depends on the quota type or metric. |
| `error.errors[].errorDetails[].quotaInfo.rolloutStatus` | `enum` Rollout status of the future quota limit. |
| `error.errors[].errorDetails[].help` | `object` Links and information to help the user resolve the error. |
| `error.errors[].errorDetails[].help.links[]` | `object` URL(s) pointing to additional information on handling the current error. |
| `error.errors[].errorDetails[].help.links[].description` | `string` Describes what the link offers. |
| `error.errors[].errorDetails[].help.links[].url` | `string` The URL of the link. |
| `error.errors[].errorDetails[].localizedMessage` | `object` A localized human-readable error message intended for end users. |
| `error.errors[].errorDetails[].localizedMessage.locale` | `string` The locale used following the specification defined at <https://www.rfc-editor.org/rfc/bcp/bcp47.txt>. Examples are: "en-US", "fr-CH", "es-MX" |
| `error.errors[].errorDetails[].localizedMessage.message` | `string` The localized error message in the above locale. |
| `warnings[]` | `object` Output only. If warning messages are generated during processing of the operation, this field will be populated. |
| `warnings[].code` | `enum` Output only. A warning code, if applicable. For example, Compute Engine returns `NO_RESULTS_ON_PAGE` if there are no results in the response. |
| `warnings[].message` | `string` Output only. A human-readable description of the warning code. |
| `warnings[].data[]` | `object` Output only. Metadata about this warning in `key: value` format. For example: ```html "data": [  {  "key": "scope",  "value": "zones/us-east1-d"  }] ``` <br /> |
| `warnings[].data[].key` | `string` Output only. A key that provides more detail on the warning being returned. For example, for warnings where there are no results in a list request for a particular zone, this key might be `scope` and the key value might be the zone name. Other examples might be a key indicating a deprecated resource and a suggested replacement, or a warning about invalid network settings (for example, if an instance attempts to perform IP forwarding but is not enabled for IP forwarding). |
| `warnings[].data[].value` | `string` Output only. A warning data value corresponding to the key. |
| `httpErrorStatusCode` | `integer` Output only. If the operation fails, this field contains the HTTP error status code that was returned. For example, a `404` means the resource was not found. |
| `httpErrorMessage` | `string` Output only. If the operation fails, this field contains the HTTP error message that was returned, such as `NOT FOUND`. |
| `selfLink` | `string` Output only. Server-defined URL for the resource. |
| `region` | `string` Output only. The URL of the region where the operation resides. Only applicable when performing regional operations. |
| `description` | `string` Output only. A textual description of the operation, which is set when the operation is created. |
| `operationGroupId` | `string` Output only. An ID that represents a group of operations, such as when a group of operations results from a `bulkInsert` API request. |
| Output only. Service-specific metadata attached to this operation. The following is a list of mutually exclusive fields. At most one of the fields will be set in a response: ||
| `setCommonInstanceMetadataOperationMetadata` | `object` Output only. If the operation is for projects.setCommonInstanceMetadata, this field will contain information on all underlying zonal actions and their state. |
| `setCommonInstanceMetadataOperationMetadata.clientOperationId` | `string` Output only. The client operation id. |
| `setCommonInstanceMetadataOperationMetadata.perLocationOperations[]` | `map (key: string, value: object)` Output only. Status information per location (location name is key). Example key: zones/us-central1-a |
| `setCommonInstanceMetadataOperationMetadata.perLocationOperations[].state` | `enum` Output only. Status of the action, which can be one of the following: `PROPAGATING`, `PROPAGATED`, `ABANDONED`, `FAILED`, or `DONE`. |
| `setCommonInstanceMetadataOperationMetadata.perLocationOperations[].error` | `object` Output only. If state is `ABANDONED` or `FAILED`, this field is populated. |
| `setCommonInstanceMetadataOperationMetadata.perLocationOperations[].error.code` | `integer` The status code, which should be an enum value of `google.rpc.Code`. |
| `setCommonInstanceMetadataOperationMetadata.perLocationOperations[].error.message` | `string` A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the `google.rpc.Status.details` field, or localized by the client. |
| `setCommonInstanceMetadataOperationMetadata.perLocationOperations[].error.details[]` | `object` A list of messages that carry the error details. There is a common set of message types for APIs to use. An object containing fields of an arbitrary type. An additional field `"@type"` contains a URI identifying the type. Example: `{ "id": 1234, "@type": "types.example.com/standard/id" }`. |
| `instancesBulkInsertOperationMetadata` | `object` |
| `instancesBulkInsertOperationMetadata.perLocationStatus[]` | `map (key: string, value: object)` Status information per location (location name is key). Example key: zones/us-central1-a |
| `instancesBulkInsertOperationMetadata.perLocationStatus[].status` | `enum` Output only. Creation status of instances.bulkInsert operation - information if the flow is rolling forward or rolling back. |
| `instancesBulkInsertOperationMetadata.perLocationStatus[].targetVmCount` | `integer` Output only. Count of VMs originally planned to be created. |
| `instancesBulkInsertOperationMetadata.perLocationStatus[].createdVmCount` | `integer` Output only. Count of VMs successfully created so far. |
| `instancesBulkInsertOperationMetadata.perLocationStatus[].failedToCreateVmCount` | `integer` Output only. Count of VMs that started creating but encountered an error. |
| `instancesBulkInsertOperationMetadata.perLocationStatus[].deletedVmCount` | `integer` Output only. Count of VMs that got deleted during rollback. |
| `getVersionOperationMetadata` | `object` |
| `getVersionOperationMetadata.inlineSbomInfo` | `object` |
| `getVersionOperationMetadata.inlineSbomInfo.currentComponentVersions` | `map (key: string, value: string)` A mapping of components to their currently-applied versions or other appropriate identifiers. |
| `getVersionOperationMetadata.inlineSbomInfo.targetComponentVersions` | `map (key: string, value: string)` A mapping of components to their target versions or other appropriate identifiers. |
| `getHealthOperationMetadata` | `object` Output only. Metadata for GetHealth operations. |
| `getHealthOperationMetadata.healthInfo` | `object` Output only. The health information. |
| `getHealthOperationMetadata.healthInfo.healthStatus` | `enum` Output only. The health status. |
| `getHealthOperationMetadata.healthInfo.unhealthyReason` | `enum` Output only. The reason for unhealthy status. |
| `getHealthOperationMetadata.healthInfo.repairCategory` | `enum` Output only. The repair category. |
| `getHealthOperationMetadata.healthInfo.availabilitySloStatus` | `enum` Output only. The availability SLO status. |
| `getHealthOperationMetadata.healthInfo.updateTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Output only. The time when health info was updated. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| End of mutually exclusive fields. ||

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/compute`
- `
  https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

### IAM Permissions

In addition to any permissions specified on the fields above, authorization requires one or more of the following [IAM](https://cloud.google.com/iam/docs/) permissions:

- `compute.addresses.use`
- `compute.addresses.useInternal`
- `compute.instances.updateNetworkInterface`
- `compute.subnetworks.use`
- `compute.subnetworks.useExternalIp`

To find predefined roles that contain those permissions, see [Compute Engine IAM Roles](https://docs.cloud.google.com/compute/docs/access/iam).